Index: bb-admin/posts.php
===================================================================
--- bb-admin/posts.php	(revision 5684)
+++ bb-admin/posts.php	(working copy)
@@ -38,19 +38,44 @@
 
 	switch ( (string) $_GET['message'] ) {
 		case 'undeleted':
-			bb_admin_notice( sprintf( _n( '<strong>Post undeleted.</strong>', '<strong>%s posts undeleted.</strong>', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Post undeleted.</strong>' );
+			} else {
+				$message = sprintf( _n( '<strong>%s post undeleted.</strong>', '<strong>%s posts undeleted.</strong>', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 		case 'deleted':
-			bb_admin_notice( sprintf( _n( '<strong>Post deleted.</strong>', '<strong>%s posts deleted.</strong>', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Post deleted.</strong>' );
+			} else {
+				$message = sprintf( _n( '<strong>%s post deleted.</strong>', '<strong>%s posts deleted.</strong>', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 		case 'spammed':
-			bb_admin_notice( sprintf( _n( '<strong>Post spammed.</strong>', '<strong>%s posts spammed.</strong>', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Post spammed.</strong>' );
+			} else {
+				$message = sprintf( _n( '<strong>%s post spammed.</strong>', '<strong>%s posts spammed.</strong>', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 		case 'unspammed-normal':
-			bb_admin_notice( sprintf( _n( '<strong>Post removed from spam.</strong> It is now a normal post.', '<strong>%s posts removed from spam.</strong> They are now normal posts.', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Post removed from spam.</strong> It is now a normal post.' );
+			} else {
+				$message = sprintf( _n( '<strong>%s post removed from spam.</strong> It is now a normal post.', '<strong>%s posts removed from spam.</strong> They are now normal posts.', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 		case 'unspammed-deleted':
-			bb_admin_notice( sprintf( _n( '<strong>Post removed from spam.</strong> It is now a deleted post.', '<strong>%s posts removed from spam.</strong> They are nowdeleted posts.', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Post removed from spam.</strong> It is now a deleted post.' );
+			} else {
+				$message = sprintf( _n( '<strong>%s post removed from spam.</strong> It is now a deleted post.', '<strong>%s posts removed from spam.</strong> They are now deleted posts.', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 	}
 }
Index: bb-admin/topics.php
===================================================================
--- bb-admin/topics.php	(revision 5684)
+++ bb-admin/topics.php	(working copy)
@@ -50,16 +50,36 @@
 
 	switch ( (string) $_GET['message'] ) {
 		case 'undeleted':
-			bb_admin_notice( sprintf( _n( '<strong>Topic undeleted.</strong>', '<strong>%s topics undeleted.</strong>', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Topic undeleted.</strong>' );
+			} else {
+				$message = sprintf( _n( '<strong>%s topic undeleted.</strong>', '<strong>%s topics undeleted.</strong>', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 		case 'deleted':
-			bb_admin_notice( sprintf( _n( '<strong>Topic deleted.</strong>', '<strong>%s topics deleted.</strong>', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Topic deleted.</strong>' );
+			} else {
+				$message = sprintf( _n( '<strong>%s topic deleted.</strong>', '<strong>%s topics deleted.</strong>', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 		case 'opened':
-			bb_admin_notice( sprintf( _n( '<strong>Topic opened.</strong>', '<strong>%s topics opened.</strong>', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Topic opened.</strong>' );
+			} else {
+				$message = sprintf( _n( '<strong>%s topic opened.</strong>', '<strong>%s topics opened.</strong>', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 		case 'closed':
-			bb_admin_notice( sprintf( _n( '<strong>Topic closed.</strong>', '<strong>%s topics closed.</strong>', $message_count ), bb_number_format_i18n( $message_count ) ) );
+			if ( 1 == $message_count ) {
+				$message = __( '<strong>Topic closed.</strong>' );
+			} else {
+				$message = sprintf( _n( '<strong>%s topic closed.</strong>', '<strong>%s topics closed.</strong>', $message_count ), bb_number_format_i18n( $message_count ) );
+			}
+			bb_admin_notice( $message );
 			break;
 	}
 }